﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using _138785_ExeciteSqlRaw_Core_MVC.Models;

using System.Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.Data.SqlClient;

namespace _138785_ExeciteSqlRaw_Core_MVC.Controllers
{
    public class HomeController : Controller
    {
        private DBCtx Context { get; }
        public HomeController(DBCtx _context)
        {
            this.Context = _context;
        }

        public IActionResult Index()
        {
            //int returned = InsertCustomer("Dharmendra", "India");
            //ViewData["Message"] = "Rows affected : " + returned;

            string query = "EXEC dbo.Customers_GetJson @Json OUTPUT";
            SqlParameter param = new SqlParameter("Json", SqlDbType.NVarChar, -1)
            {
                Direction = ParameterDirection.Output
            };
            this.Context.Database.ExecuteSqlRaw(query, param);
            string json = Convert.ToString(param.Value);

            ViewData["Message"] = json;
            return View();
        }

        public int InsertCustomer(string name, string country)
        {
            int rowsAffected = 0;
            try
            {
                string query = "EXEC dbo.Customers_InsertCustomer @Name, @Country";
                SqlParameter pName = new SqlParameter("@Name", name);
                SqlParameter pCountry = new SqlParameter("@Country", country);
                rowsAffected = this.Context.Database.ExecuteSqlRaw(query, pName, pCountry);
            }
            catch (Exception ex)
            {
            }

            return rowsAffected;
        }
    }
}
